//Implizite Flächen mit Meshtracing und Multithreading
//Drehung um x-Achse: Taste 'x'   Drehung um y-Achse: Taste 'y'
//Punkte auf den Parallelstrahlen starten an der Projektionsfläche ABCD
//Jedem Startpunkt eines Strahls wird, abhängig vom Verlauf, ein Pixel zugeordent
//Es wird daher ein zweidimensionales Bild erzeugt

int aufloesung=800;// = width!
int aT =10;//Anzahl Threads - aT muss Teiler sein von auflöesung - Maximum aT=16 !
int abstandScreen;
int anteil;
float anteilErledigt11 ;//misst den Fortschritt in Thread 11
float laenge;
float a=1.0/255.0;
float b=1.0/255.0/255.0;
//Screen:
float[][] A = new float[aT][3];
float[][] B = new float[aT][3];
float[][] C = new float[aT][3];
float[][] D = new float[aT][3];
ArrayList<float[]>[] startPunkte = new ArrayList[aT];
ArrayList<float[]>[] bildPunkte = new ArrayList[aT];
ArrayList<float[]>[] raumBildPunkte = new ArrayList[aT];
float[][]raumBildPunkt = new float[aT][aT];;
float[]di = new float[aT]; //distance estimation for every Thread
float wh;;//Abstand untere-obere Grenze
float alY ;//Drehwinkel y-Achse
float alX ;//Drehwinkel x-Achse
float fak ;//Umrechnungsfaktor von Pixel in Raum
float[] abstand = new float[aT];//...vom Ursprung
//float fVariante;//Farbgebung durch Zufall;
PImage bild;
boolean farbigZeichnen = false;
boolean nextStep = true;
ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
float[]tempD = new float[aT];//verwendet für hell-dunkel
float[]tempF = new float[aT];//verwendet für Farbe
float[] grauWerte = new float[aufloesung*aufloesung];
float[] farbWerte = new float[aufloesung*aufloesung];
float[][] raumENV = new float[aT][3];
//-------------------------------------------------
void setup(){
  size(800,800,P2D);
  colorMode(HSB);
  //scale(0.1);
  wh = 3;//max Ausdehnung in allen Achsen (Würfel Kantenlänge 8, Mittelpunkt Ursprung (Zoom: wh=0.7)
  fak = wh/aufloesung;//enstspricht Entfernung zwischen den einzelnen Pixeln
  anteil = aufloesung/aT; ; //Anteil für jeden Thread
  alX = 0; alY = 0; 
  abstandScreen = 600;  
 // fVariante = random(50,255);
  initialisieren();
  starten();
}
//-----------------------------------------------------------
void draw(){
  if(nextStep){  
    loadPixels();
    PImage bild = createImage(width,height,RGB);
    
     if(farbigZeichnen){
       for (int i = 0; i < aufloesung*aufloesung; i++) {  
          bild.pixels[i] =  color(farbWerte[i],240,grauWerte[i]);     //grauWerte[i]      
       }
     }else{
       for (int i = 0; i < aufloesung*aufloesung; i++) {  
         bild.pixels[i] =  color(grauWerte[i]);            
       }
     }    
     println("Kantenlänge des zu untersuchenden Bereichs (Würfel mit O als Zentrum): "+wh); 
     println("Ein Pixel enspricht der Länge: "+fak," Abstand Screen: "+abstandScreen);
     println("Time: "+second());//bei distEst 0.3*  : 405, bei 0.5* : 84 => mehr Kontrast bei 0.3
     println("Winkel Drehung y-Achse: "+alY+ " x-Achse: "+ alX);
    
     image(bild,0,0);
     save("bild.png");  
     nextStep=false;
     System.gc();
    }
}
//----------------------------------------------------------------------
void starten(){   
  //Platz für Erweiterungen
  multiThreadsStarten();  
}
//--------------------------------------------------------------------------
void multiThreadsStarten(){
   workers.clear();
   for (int i=0; i<aT; i++)
    {
      workers.add(new WorkThread(i)); 
    }
    for (WorkThread worker : workers) {  
      while (worker.running)
      {       
        try{
        Thread.sleep(10);  
        }catch (Exception e) {  }  ;                
      }
    }
    for(int n =0; n<aT; n++){
      tempD = workers.get(n).pixValuesGray[n];  
      tempF = workers.get(n).pixValuesColor[n];
      for(int i = 0; i<aufloesung*anteil;i++){
            grauWerte[i+n*aufloesung*anteil]=tempD[i];
            farbWerte[i+n*aufloesung*anteil]=tempF[i];
      }
    }
}
//------------------------------------------------------------
float[] matrixMalvector(float[][] M, float[] V){
    float[] ergebnisV = new float[3];
      for(int i=0;i<3;i++){ 
        ergebnisV[i] = M[i][0]*V[0]+M[i][1]*V[1]+M[i][2]*V[2];      
      }
    return ergebnisV;
}
//---------------------------------------------------------------------
float[] drehenY(int n, float alpha, float[] Vector){
    alY = alpha;
    float[][] Dy =  { {cos(alY) ,   0   ,sin(alY)},
                      {  0     ,   1   ,   0   },
                      {-sin(alY),   0   , cos(alY)}   };
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dy,Vector);
    return gedrehterV;    
}
//---------------------------------------------------------------------
float[] drehenX(int n, float alpha, float[] Vector){
    alX = alpha;
      float[][] Dx =  {{  cos(alX) ,   -sin(alX),    0    },
                      {   sin(alX)  ,   cos(alX),    0    },
                      {      0     ,          0 ,    1    }};
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dx,Vector);
    return gedrehterV;    
}
//-----------------------------------------------------------------------------------
void gedrehtePunkteBerechnen(int n,float winkelY, float winkelX){
  bildPunkte[n] = new ArrayList<float[]>();raumBildPunkte[n] = new ArrayList<float[]>();
  float[] richtungEV ={-1,0,0};
  alY = winkelY;alX = winkelX;
  raumENV[n] = drehenY(n,alY,richtungEV); 
  raumENV[n] = drehenX(n,alX,raumENV[n]);//if(n==5)print(raumENV[5][0],raumENV[5][1],raumENV[5][2]+"   ");
  for(int j=0;j<aufloesung*aufloesung/aT; j++){ //if(n==1 && j<10)   println( startPunkte[n].get(j));
    float[] bP =drehenY(n,alY,startPunkte[n].get(j));bP = drehenX(n,alX,bP); 
    float[] raumBP = {bP[0]*fak,bP[1]*fak,bP[2]*fak};   
    bildPunkte[n].add(bP);raumBildPunkte[n].add(raumBP);
  }
}
//---------------------------------------------------------------------
void startPunkteBerechnen(int n, int abstandScreen){
  //abstandScreen, da konstant, müsste hier nicht übergeben werden. 
  //Ist für Folgeprogramme hier schon mal eingeführt
  startPunkte[n] = new ArrayList<float[]>();
  for(int i=n*aufloesung/aT; i<(n+1)*aufloesung/aT; i++){
     for(int j=0;j<aufloesung; j++){     
       float[] p = {-abstandScreen,-aufloesung/2+j,-aufloesung/2+i};    
       startPunkte[n].add(p);
     }
  } 
}
//---------------------------------------------------------------------------
void initialisieren(){
 anteilErledigt11 = 0;
 
    for(int n = 0; n < aT; n++){
         A[n][0]=-abstandScreen;A[n][1]=-aufloesung/2;A[n][2]=-aufloesung/2;
    }  
    for(int n = 0; n < aT; n++){
         B[n][0]=-abstandScreen;B[n][1]=-aufloesung/2;B[n][2]=-aufloesung/2;
    }  
    for(int n = 0; n < aT; n++){
         C[n][0]=-abstandScreen;C[n][1]=-aufloesung/2;C[n][2]=-aufloesung/2;
    }  
    for(int n = 0; n < aT; n++){
         D[n][0]=-abstandScreen;D[n][1]=-aufloesung/2;D[n][2]=-aufloesung/2;
    }  
 
    for (int i = 0; i < aT; i++) {
              startPunkte[i] = new ArrayList<float[]>();
    }
    for (int i = 0; i < aT; i++) {
              bildPunkte[i] = new ArrayList<float[]>();
    }
    for (int i = 0; i < aT; i++) {
              raumBildPunkte[i] = new ArrayList<float[]>();
    }
}
//-------------------------------------------------------------------------
void keyPressed(){
   if (key == 'y') {//Drehung um y-Achse
    alY = alY + PI/8;    
    initialisieren();    
    nextStep = true;
    starten();    
  }
  if (key == 'x') {//Drehung um x-Achse
    alX = alX + PI/6;   
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'g') {//farbig/grau Zeichnen
    farbigZeichnen = !farbigZeichnen;
    initialisieren();    
    nextStep = true;
    starten();
  }
   if (key == 'w') {//Farbe wechseln
   // fVariante = random(50,255);
    initialisieren();    
    nextStep = true;
    starten();
  }
  
}
//////////////////////////////////////////////////////////////////////////////////
class WorkThread implements Runnable {

  protected boolean running = true;
  private int nummer;
   
  ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
  
  float[][] pixValuesGray  =  new float[aT][aufloesung*anteil];//for every Thread
  float[][] pixValuesColor =  new float[aT][aufloesung*anteil];
       
  public WorkThread (int nummer){
    this.nummer = nummer;
    Thread thread = new Thread(this);
    thread.start();
  }
  public void run() {       
      this.running = true;
      println("Die interne Threadnummer ist: " 
       + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
       
        switch(nummer){  
      case 0:pixelBerechnen( 0); break;              
      case 1:pixelBerechnen( 1); break;                
      case 2:pixelBerechnen( 2); break;                 
      case 3:pixelBerechnen( 3); break;            
      case 4:pixelBerechnen( 4); break;            
      case 5:pixelBerechnen( 5); break;          
      case 6:pixelBerechnen( 6); break;       
      case 7:pixelBerechnen( 7); break;            
      case 8:pixelBerechnen( 8); break;       
      case 9:pixelBerechnen( 9); break;          
      case 10:pixelBerechnen(10); break;            
      case 11:pixelBerechnen(11); break;    
      case 12:pixelBerechnen(12); break;            
      case 13:pixelBerechnen(13); break;       
      case 14:pixelBerechnen(14); break;          
      case 15:pixelBerechnen(15); break;            
     
    }
    println("Threads mit Nummer "+nummer+" ist fertig!");   
    this.running = false;
  }
  
 void pixelBerechnen(int n){//if und else if nur einmal => Beschleunigung
     startPunkteBerechnen(n,abstandScreen);
     gedrehtePunkteBerechnen(n,alY,alX);   
     int startWert = 500;//Startindex für Schrittzählung auf dem Strahl -muss angepasst werden
     float min = 0; float max = 255;
       for(int j = 0; j<aufloesung*aufloesung/aT;j++){
          raumBildPunkt[n] = raumBildPunkte[n].get(j); 
          for(int k = startWert; k>-1 ; k--){
             di[n] = distance(n,raumBildPunkt[n][0],raumBildPunkt[n][1],raumBildPunkt[n][2]);         
             if(di[n] < 0.00001){    
                 float K = map(k,max,min,255,0); //Spreizung - max und   min muss durch Test bestimmt werden  
                 pixValuesGray[n][j] = K;  //wird benötigt zur Helligkeitsanpassung  
                 if(farbigZeichnen){
                    abstand[n] = sqrt(sq(raumBildPunkt[n][0])+sq(raumBildPunkt[n][1])+sq(raumBildPunkt[n][1]));
                    pixValuesColor[n][j] = k%255;
                 }                          
                 break;
            }else{             
               raumBildPunkt[n][0] = raumBildPunkt[n][0] -0.005*raumENV[n][0];    
               raumBildPunkt[n][1] = raumBildPunkt[n][1] -0.005*raumENV[n][1];    
               raumBildPunkt[n][2] = raumBildPunkt[n][2] -0.005*raumENV[n][2];  
            } //end of for else k       
         }//end of for k
         if(n==11){//Info über Rechenfortschritt
          anteilErledigt11=j;
         }       
    }//end of for j  
 }//end of pixelBerechnen  
//----------------------------------------------------------------------
 float distance(int n, float x1, float y1, float z1){
    int   N  = 0;
    float x = x1;
    float y = y1;
    float z = z1;
    float Rad = sq(x)+sq(y)+sq(z)-1;   
    float[]  Dist = new float[aT];
    Dist[n] = Rad;  
    return Dist[n];
 } //end of distance
//-------------------------------------------------------------------  
}//end of WorkThread
