//Demo-Sketch für Meshtracing

int aufloesung = 80;
float laenge;
//Elementarpunkte:
float[] nEV = {-1, 0, 0};//Normalen-Einheitsvektor
float[] A = {-160, 40,-40};
float[] B = {-160, 40 ,40};
float[] C = {-160,-40, 40};
float[] D = {-160,-40,-40};
float[] M = {-0,0,0};
float[] beispP = new float[3];//Beispielpunkt 
float[] beispBP; //Beispiel-Bildpunkt zeichnen
float[] beispREV ;//Beispiel Einheitsrichtungsvektor
float[] punkteAufRay = new float[3];//Beispielpunkte auf ray in Zeichnung
ArrayList<float[]> startPunkte ;
ArrayList<float[]> bildPunkte ;
ArrayList<float[]> richtungEV;

float al ;//Drehwinkel

//-------------------------------------------------
void setup(){
  size(800,800,P3D);
  al=0;
  startPunkteBerechnen();//println(startPunkte.get(0));
} 

//-----------------------------------------------------------
void draw(){
  background(255);
  gedrehtePunkteBerechnen(al); //...mit Beispiel 0,0  
  zeichnenModell();
 
  al=0.004;
 // noLoop();
}

//Zeichnung im Maßstab 1:10---------------------------------------------
void zeichnenModell(){
  float verg =2;
  scale(verg);  
  translate(width/2/verg,height/2/verg,0);
  fill(200,0,0); 
  noStroke();
  sphere(60);//fest  
  stroke(0);
  strokeWeight(4);    
  bespielPunktezeichnen();
  
  point(A[0],A[1],A[2]); point(B[0],B[1],B[2]);
  point(C[0],C[1],C[2]); point(D[0],D[1],D[2]);
  point( beispBP[0],beispBP[1],beispBP[2]);
  linienZeichnen();
}

//------------------------------------------------------------
float[] matrixMalvector(float[][] M, float[] V){
    float[] ergebnisV = new float[3];
      for(int i=0;i<3;i++){ 
        ergebnisV[i] = M[i][0]*V[0]+M[i][1]*V[1]+M[i][2]*V[2];      
      }
  //  println(ergebnisV);
    return ergebnisV;
}

//---------------------------------------------------------------------
float[] drehenY(float alpha, float[] Vector){
    al = alpha;//println(al);
      float[][] Dy =  { {cos(al) ,   0   ,sin(al)},
                      {  0     ,   1   ,   0   },
                      {-sin(al),   0   ,cos(al)}   };
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dy,Vector);
  //  printArray(gedrehterV);println(); printArray(Matrix[0]);println();printArray(Matrix[1]);println();printArray(Matrix[2]);
    return gedrehterV;    
}

//-------------------------------------------------------------------
void startPunkteBerechnen(){
  startPunkte = new ArrayList<float[]>();
  for(int i=0; i<aufloesung; i++){
     for(int j=0;j<aufloesung; j++){
        float[] p = {-aufloesung-80,-40+j,-40+i};
        startPunkte.add(p);
     }
  } 
}
//-----------------------------------------------------------------------------------
void gedrehtePunkteBerechnen(float winkel){//nur einmal in setup() ausgeführt
  bildPunkte = new ArrayList<float[]>();
  richtungEV = new ArrayList<float[]>();
  al = winkel; //println("start "+startPunkte.size());
  nEV = drehenY(al,nEV);//println(nEV);println("oben");
  A = drehenY(al,A);//println(A);println();
  B = drehenY(al,B);
  C = drehenY(al,C);
  D = drehenY(al,D);//println(D);
  M = drehenY(al,M);
 
  for(int i=0; i<aufloesung; i++){
     for(int j=0;j<aufloesung; j++){//println(i,j);
        float[] bP = drehenY(al,startPunkte.get(j+i*aufloesung));//if(i== 0 & j== 0) {println(bP);println();}       
        bildPunkte.add(bP);        
     }
   }     
   startPunkte.clear();   
   for(int i=0; i<aufloesung; i++){
     for(int j=0;j<aufloesung; j++){
       startPunkte.add(bildPunkte.get(j+i*aufloesung));
     }
   }   
  //Paramter iP nach unten, jP nach rechts!!
  int iP = 20; int jP = 30;   
  beispBP = bildPunkte.get(jP+iP*aufloesung);//println(beispBP);  println(al);
  
}

//--------------------------------------------------------------------
void bespielPunktezeichnen(){
 
  stroke(200,0,200);//magenta
  strokeWeight(3);
  for(int k=0;k<=10;k++){
     punkteAufRay[0] = beispBP[0] - 10*k*nEV[0]; 
     punkteAufRay[1] = beispBP[1] - 10*k*nEV[1]; 
     punkteAufRay[2] = beispBP[2] - 10*k*nEV[2];
     point(punkteAufRay[0],punkteAufRay[1],punkteAufRay[2]);//println(punkteAufRay[0],punkteAufRay[1],punkteAufRay[2]);   
  }
  stroke(0);
  strokeWeight(4);
  point(beispBP[0],beispBP[1],beispBP[2]);//Startpunkt
  
  strokeWeight(1);
 /* for(float[] p: startPunkte){
     point(p[0],p[1],p[2]);//alle Punkte
  }*/
  for(int i = 0; i<startPunkte.size();i=i+7){
     point(startPunkte.get(i)[0],startPunkte.get(i)[1],startPunkte.get(i)[2]);
  }
}

//-------------------------------------------------------------------------------------------------------
void linienZeichnen(){
  strokeWeight(1);
  stroke(0);//schwarz  
  line(M[0],M[1],M[2],M[0]-160*nEV[0],M[1]-160*nEV[1],M[2]-160*nEV[2]);
  
  stroke(0,0,200);//blauer Rahmen
  line(A[0],A[1],A[2],B[0],B[1],B[2]);
  line(B[0],B[1],B[2],C[0],C[1],C[2]);
  line(C[0],C[1],C[2],D[0],D[1],D[2]);
  line(D[0],D[1],D[2],A[0],A[1],A[2]);
  
  stroke(0,200,0); //grün
  line(A[0],A[1],A[2],A[0]-160*nEV[0],A[1]-160*nEV[1],A[2]-160*nEV[2]);  
  line(B[0],B[1],B[2],B[0]-160*nEV[0],B[1]-160*nEV[1],B[2]-160*nEV[2]);
  line(C[0],C[1],C[2],C[0]-160*nEV[0],C[1]-160*nEV[1],C[2]-160*nEV[2]); 
  line(D[0],D[1],D[2],D[0]-160*nEV[0],D[1]-160*nEV[1],D[2]-160*nEV[2]);
    
  stroke(0,255,255);//türkis
  line(beispBP[0],beispBP[1],beispBP[2],
       beispBP[0]-2*aufloesung*nEV[0],beispBP[1]-2*aufloesung*nEV[1],beispBP[2]-2*aufloesung*nEV[2]);
   
  stroke(0);
}
